<?php
function jmetc_refresh_comment_cache() {
	global $wpdb;
	
	$jmetcop['icon'] = get_option('jmetc_icon');
	$jmetc_options = get_option('jmetc_commenters');
			
	$jmevar['cache'] = '<div class="top-contributors">'."\n";
	
	/* if include/exclude categories, do advanced query */
	if($jmetc_options['show_category'] == 1) {
		
		/* create category list id */
		$jmevar['catarray'] = implode(",",$jmetc_options['category_list']);
		
		/* create category inc/exc sql */
		if($jmetc_options['cat_inc_exc'] == 0) 
			$jmevar['catsql'] = "AND t.term_id IN ($jmevar[catarray])";
		else 
			$jmevar['catsql'] = "AND t.term_id NOT IN ($jmevar[catarray]) AND t.taxonomy = 'category'";
		
		
		/* additional query changes */
		$jmevar['authorsql'] = jme_get_author_exclude(3,$jmetc_options['exclude_author']);
		$jmevar['timeInterval'] = jme_get_time_interval(3,$jmetc_options);		
		$jmevar['groupby'] = ($jmetc_options['count_by'] == 0) ? 'c.comment_author_email' : 'c.comment_author';
		
		/* create sql query */
		$query = "SELECT 	
						COUNT(c.comment_ID) AS `comment_count`,
						c.comment_author,
						c.comment_author_email,
						c.comment_author_url
					FROM $wpdb->comments c
					LEFT JOIN $wpdb->term_relationships r
					ON c.comment_post_ID = r.object_id
					LEFT JOIN $wpdb->term_taxonomy t
					ON r.term_taxonomy_id = t.term_taxonomy_id
					WHERE c.comment_approved = 1
					AND c.comment_type = ''
					$jmevar[catsql]
					$jmevar[authorsql]
					$jmevar[timeInterval]
					GROUP BY $jmevar[groupby]
					ORDER BY comment_count DESC
					LIMIT $jmetc_options[limit]
				";
	} else {
		/* else if no include/exclude categories, do basic query */
	
		$jmevar['authorsql'] = jme_get_author_exclude(2,$jmetc_options['exclude_author']);
		$jmevar['timeInterval'] = jme_get_time_interval(2,$jmetc_options);
		$jmevar['groupby'] = ($jmetc_options['count_by'] == 0) ? 'comment_author_email' : 'comment_author';
		
		$query = "	SELECT 	COUNT(comment_ID) AS `comment_count`,
						comment_author,
						comment_author_email,
						comment_author_url
					FROM $wpdb->comments
					WHERE comment_approved = 1
					AND comment_type = ''
					$jmevar[authorsql]
					$jmevar[timeInterval]
					GROUP BY $jmevar[groupby]
					ORDER BY comment_count DESC
					LIMIT $jmetc_options[limit]
				";
	}
				
	/* execute query */
	$gettc = $wpdb->get_results( $query );

	/* if valid results */
	if($gettc) {
			
			// If format is List Style
			if($jmetc_options['format'] == 1) {
				$jmevar['count'] = 0;
				
				if($jmetc_options['widget_columns'] > 1) {
					$jmevar['rows'] = true;
					$jmevar['cache'] .= '<table cellspacing="0"><tr>';
				}
				
				foreach($gettc as $tc) {
					if($jmevar['rows']) $jmevar['cache'] .= '<td>';
					$jmevar['cache'] .= '<div class="list">';
				
					$jmevar['username'] = jmetc_do_keywordluv($tc->comment_author,$tc->comment_author_url,$jmetc_options['keywordluv'],$jmetc_options['rel_links']);
				
					if($jmetc_options['show_avatar'] == 1) {
						$jmevar['cache'] .= get_avatar($tc->comment_author_email, $jmetc_options['avatar_size']);
					}
				
					$jmevar['cache'] .= '<div class="tc-user">' . $jmevar['username'] . '</div>';
						if($jmetc_options['show_count'] == 1) {
							$jmevar['cache'] .= '<div class="tc-count">';
							$jmevar['cache'] .= ($tc->comment_count == 1) ? sprintf(__("%s comment", 'jmetc'), $tc->comment_count) :
								sprintf(__("%s comments", 'jmetc'), number_format($tc->comment_count));
							$jmevar['cache'] .= '</div>';
						}
					$jmevar['cache'] .= '<div style="clear:both;"></div></div>'."\n";
					$jmevar['count']++;
					
					if($jmevar['rows']) {
						$jmevar['cache'] .= '</td>';
						if($jmevar['count'] % $jmetc_options['widget_columns'] == 0) $jmevar['cache'] .= '</tr><tr>';
					}
				}
				if($jmevar['rows']) $jmevar['cache'] .= "</tr></table>\n";
			}
			
			// If format is Gallery Style
			if($jmetc_options['format'] == 2) {
				
				foreach($gettc as $tc) {

					/* generate user avatar */
					$gavatar = get_avatar($tc->comment_author_email, $jmetc_options['avatar_size']);
					
					$jmevar['cache'] .= '<div class="gallery">'."\n";
					
					/* generate tooltip info */
					$jmevar['tt'] = 'title="<div class=\'tc-user\'>' . $tc->comment_author . '</div>';
						if($jmetc_options['show_count'] == 1) {
							$jmevar['tt'] .= '<div class=\'tc-count\'>';
							$jmevar['tt'] .= ($tc->comment_count == 1) ? sprintf(__("%s comment", 'jmetc'), $tc->comment_count) :
								sprintf(__("%s comments", 'jmetc'), number_format($tc->comment_count));
							$jmevar['tt'] .= '</div>';
						}
					$jmevar['tt'] .= '" ';
					/* end tooltip info */	
								
					/* add tooltip info to avatar */
					$jmevar['cache'] .= str_replace('<img','<img '.$jmevar['tt'],$gavatar);
					
					$jmevar['cache'] .= "</div>\n";
				}
				$jmevar['cache'] .= '<div style="clear:both;"></div>';
			}
				
			/* 
				Create array of top users to add Star Icon next to in comments
				This part only applied if threshold is set to 0, this puts top 10 users in the array
				If threshold is not 0, a new query is created below
			*/			
			if (($jmetcop['icon']['show_icon'] == 1) && ($jmetcop['icon']['comment_limit'] == '0')) {
				foreach($gettc as $tc) {
					$jmetc_options['toplist']['name'][] = $tc->comment_author;
				}
			}
			
		/* if no results from query, no commeters */
		} else {
			$jmevar['cache'] .= __('No commenters found.', 'jmetc');
		}
		$jmevar['cache'] .= "</div>\n";

		/* 
			Create array of top users to add Star Icon, if threshold is not 0
			
		*/
		if($jmetcop['icon']['show_icon'] == 1 && $jmetcop['icon']['comment_limit'] != '0') {
			/* 
				Find the minimum comment count needed for star.
				If threshold is array, get first value, else threshold is the minimum limit.
			*/
			if(strpos($jmetcop['icon']['comment_limit'],",")) {
				$slist = explode(",",$jmetcop['icon']['comment_limit']);
				$starLimit = $slist[0];
			} else {
				$starLimit = $jmetcop['icon']['comment_limit'];
			}

			/* set toplist array */
			$jmetc_options['toplist'] = array();
			
			/* if include/exclude categories, do advanced query */
			if($jmetc_options['show_category'] == 1) {
		
				/* create category list id */
				$jmevar['catarray'] = implode(",",$jmetc_options['category_list']);
		
				/* create category inc/exc sql */
				if($jmetc_options['cat_inc_exc'] == 0) 
					$jmevar['catsql'] = "AND t.term_id IN ($jmevar[catarray])";
				else 
					$jmevar['catsql'] = "AND t.term_id NOT IN ($jmevar[catarray]) AND t.taxonomy = 'category'";
		
		
				/* additional query changes */
				$jmevar['authorsql'] = jme_get_author_exclude(3,$jmetc_options['exclude_author']);
				$jmevar['timeInterval'] = jme_get_time_interval(3,$jmetc_options);		
				$jmevar['groupby'] = ($jmetc_options['count_by'] == 0) ? 'c.comment_author_email' : 'c.comment_author';
		
				/* create sql query */
				$query = "SELECT 	
								COUNT(c.comment_ID) AS `comment_count`,
								c.comment_author
							FROM $wpdb->comments c
							LEFT JOIN $wpdb->term_relationships r
							ON c.comment_post_ID = r.object_id
							LEFT JOIN $wpdb->term_taxonomy t
							ON r.term_taxonomy_id = t.term_taxonomy_id
							WHERE c.comment_approved = 1
							AND c.comment_type = ''
							$jmevar[catsql]
							$jmevar[authorsql]
							$jmevar[timeInterval]
							GROUP BY $jmevar[groupby]
							HAVING `comment_count` >= '" .$starLimit . "'
						";

			} else {
				/* else if no category includes/excludes, do standard query */
				
				$jmevar['authorsql'] = jme_get_author_exclude(2,$jmetc_options['exclude_author']);
				$jmevar['timeInterval'] = jme_get_time_interval(2,$jmetc_options);
				$jmevar['groupby'] = ($jmetc_options['count_by'] == 0) ? 'comment_author_email' : 'comment_author';

		
				$query = "	SELECT 	
								COUNT(comment_ID) AS `comment_count`,
								comment_author
							FROM $wpdb->comments
							WHERE comment_approved = 1
							AND comment_type = ''
							$jmevar[authorsql]
							$jmevar[timeInterval]
							GROUP BY $jmevar[groupby]
							HAVING `comment_count` >= '" . $starLimit . "'
					";

			}
			
			/* get result for top contributor star icons */
			$gettc = $wpdb->get_results( $query );
		
			if($gettc) {			
				foreach($gettc as $tc) {				
					$jmetc_options['toplist']['name'][] = $tc->comment_author;
					$jmetc_options['toplist']['post_count'][$tc->comment_author] = $tc->comment_count;
				}
			}
		}

		$jmetc_options['cache'] = $jmevar['cache'];

		update_option('jmetc_commenters', $jmetc_options);
}

// If listing Top Post Authors //
function jmetc_refresh_author_cache() {
	global $wpdb, $jmetcop;
	
	$jmetc_options = get_option('jmetc_authors');

	$jmevar['cache'] = '<div class="top-contributors">'."\n";

	$jmevar['authorsql'] = jme_get_author_exclude(1,$jmetc_options['exclude_author']);
	$jmevar['timeInterval'] = jme_get_time_interval(1,$jmetc_options);
	
	/* if include/exclude categories, category query */
	if($jmetc_options['show_category'] == 1) {
		
		/* create category list id */
		$jmevar['catarray'] = implode(",",$jmetc_options['category_list']);
		
		/* create category inc/exc sql */
		if($jmetc_options['cat_inc_exc'] == 0) 
			$jmevar['catsql'] = "AND t.term_id IN ($jmevar[catarray])";
		else 
			$jmevar['catsql'] = "AND t.term_id NOT IN ($jmevar[catarray]) AND t.taxonomy = 'category'";
		
		$query = "	SELECT
						COUNT(DISTINCT(a.ID)) AS `post_count`,
						b.ID,
						b.display_name,
						b.user_email,
						b.user_url
					FROM $wpdb->posts a
					LEFT JOIN $wpdb->users b
					ON a.post_author = b.ID
					LEFT JOIN $wpdb->term_relationships r
					ON a.ID = r.object_id
					LEFT JOIN $wpdb->term_taxonomy t
					ON r.term_taxonomy_id = t.term_taxonomy_id
					WHERE a.post_status = 'publish'
					AND a.post_type = 'post'
					$jmevar[catsql]
					$jmevar[authorsql]
					$jmevar[timeInterval]
					GROUP BY b.ID
					ORDER BY post_count DESC
					LIMIT $jmetc_options[limit]
				";

	} else {
		/* if no category include/exclude do normal query */
		
		$query = "	SELECT 	
						COUNT(a.ID) AS `post_count`,
						b.ID,
						b.display_name,
						b.user_email,
						b.user_url
					FROM $wpdb->posts a
					LEFT JOIN $wpdb->users b
					ON a.post_author = b.ID
					WHERE a.post_status = 'publish'
					AND a.post_type = 'post'
					$jmevar[authorsql]
					$jmevar[timeInterval]
					GROUP BY b.ID
					ORDER BY post_count DESC
					LIMIT $jmetc_options[limit]
				";
	}			
		
		$gettc = $wpdb->get_results( $query );

		if($gettc) {
		
			if($jmetc_options['format'] == 1) {
				$jmevar['count'] = 0;
				
				if($jmetc_options['widget_columns'] > 1) {
					$jmevar['rows'] = true;
					$jmevar['cache'] .= '<table cellspacing="0"><tr>';
				}
				
				foreach($gettc as $tc) {
					if($jmevar['rows']) $jmevar['cache'] .= '<td>';
					$jmevar['cache'] .= '<div class="list">';
				
					if($jmetc_options['author_page']) {
						$jmevar['username'] = '<a href="' . get_author_posts_url($tc->ID) . '">' . $tc->display_name . '</a>';
					} else {
						$jmevar['username'] = jmetc_do_keywordluv($tc->display_name,$tc->user_url,$jmetc_options['keywordluv'],$jmetc_options['rel_links']);
					}
					
					/*  if link to Author Page */
					if($jmetc_options['author_page']) $jmevar['cache'] .= '<a ' . jmetc_rel_link($jmetc_options['rel_links']) . 'href="' . get_author_posts_url($tc->ID) . '">';
					
					/* generate user Avatar */
					if($jmetc_options['show_avatar'] == 1) 
						$jmevar['cache'] .= get_avatar($tc->user_email, $jmetc_options['avatar_size']);

					/* end link to Author page */
					if($jmetc_options['author_page']) $jmevar['cache'] .= '</a>';
				
				
					$jmevar['cache'] .= '<div class="tc-user">' . $jmevar['username'] . '</div>';
						if($jmetc_options['show_count'] == 1) {
							$jmevar['cache'] .= '<div class="tc-count">';
							$jmevar['cache'] .= ($tc->post_count == 1) ? sprintf(__("%s post", 'jmetc'), $tc->post_count) :
								sprintf(__("%s posts", 'jmetc'), number_format($tc->post_count));
							$jmevar['cache'] .= '</div>';
						}
					$jmevar['cache'] .= '<div style="clear:both;"></div></div>'."\n";
					$jmevar['count']++;
					
					if($jmevar['rows']) {
						$jmevar['cache'] .= '</td>';
						if($jmevar['count'] % $jmetc_options['widget_columns'] == 0) $jmevar['cache'] .= '</tr><tr>';
					}
					if($jmevar['rows']) $jmevar['cache'] .= "</tr></table>\n";
				}
			}
		
			if($jmetc_options['format'] == 2) {
				
				foreach($gettc as $tc) {
					
					/* if linking to Author Page */
					if($jmetc_options['author_page']) $jmevar['cache'] .= '<a href="'.get_author_posts_url($tc->ID).'">';
						
					/* generate user avatar */
					$gavatar = get_avatar($tc->user_email, $jmetc_options['avatar_size']);
					
					$jmevar['cache'] .= '<div class="gallery">'."\n";
					
					/* create tooltip info */
					$jmevar['tt'] = 'title="<div class=\'tc-user\'>' . $tc->display_name . '</div>';
					if($jmetc_options['show_count'] == 1) {
						$jmevar['tt'] .= '<div class=\'tc-count\'>';
						$jmevar['tt'] .= ($tc->post_count == 1) ? sprintf(__("%s post", 'jmetc'), $tc->post_count) :
							sprintf(__("%s posts", 'jmetc'), number_format($tc->post_count));
						$jmevar['tt'] .= '</div>';
					}
					$jmevar['tt'] .= '" ';
					/* end tooltip info */
								
					$jmevar['cache'] .= str_replace('<img','<img '.$jmevar['tt'],$gavatar);
					
					/* close link to Author page */
					if($jmetc_options['author_page']) $jmevar['cache'] .= '</a>';
					

					$jmevar['cache'] .= "</div>\n";
				}
				$jmevar['cache'] .= '<div style="clear:both;"></div>';
			}
		} else {
			$jmevar['cache'] .= __('No authors found.', 'jmetc');
		}
		
		$jmevar['cache'] .= "</div>\n";
	
		$jmetc_options['cache'] = $jmevar['cache'];

		update_option('jmetc_authors', $jmetc_options);
}

function jme_get_author_exclude($type,$the_authors) {
	$author_sql = '';
	if(trim($the_authors) != '') {
		$authorlist = array();
		$authors = explode(",",$the_authors);
		for($i=0;$i<count($authors);$i++) {
			if(trim($authors[$i]) != '') {
				$authorlist[] = strtolower(trim($authors[$i]));
			}
		}
		$al = implode("','",$authorlist);		
		if($al != '') {
			if($type == 1) {
				$author_sql = "AND LOWER(b.user_email) NOT IN('" . $al . "')";
			} else if($type == 2) {
				$author_sql = "AND LOWER(comment_author_email) NOT IN('" . $al . "')";
			} else if($type == 3) {
				$author_sql = "AND LOWER(c.comment_author_email) NOT IN('" . $al . "')";
			}
		}
	}
	return $author_sql;	
}
function jme_get_category_list_id() {
	global $wpdb;
	
	$query = "	SELECT t.term_id, t.name
					FROM $wpdb->terms t
					LEFT JOIN $wpdb->term_taxonomy a
					ON t.term_id = a.term_id
					WHERE a.taxonomy = 'category'
					ORDER BY t.name ASC";
	$gettc = $wpdb->get_results( $query );
	return $gettc;
}

function jme_get_time_interval($type,$options) {
	$timeInterval = '';
	$currenttime = time();
	if($options['time_limit_type'] == 2) {

		$basetime = 60 * 60 * 24; // 1 day of time
		
		if ($options['time_limit_interval'] == 1) {
			$time = $basetime; // last day
		} else if ($options['time_limit_interval'] == 2) {
			$time = $basetime * 7; // last week
		} else if ($options['time_limit_interval'] == 3) {
			$time = $basetime * 30; // last month
		} else if ($options['time_limit_interval'] == 4) {
			$time = $basetime * 365; // last year
		}
		
		$int = (is_numeric(trim($options['time_limit_int']))) ? trim($options['time_limit_int']) : 1;
		$time = $time * $int; // multiply by number of intervals
		
		$subTime = $currenttime - $time;
		$dateLimit = gmdate('Y-m-d H:i:s', $subTime);
		if($type == 1) {
			$timeInterval = "AND a.post_date_gmt > '" . $dateLimit . "'";
		} else if($type == 2) {
			$timeInterval = "AND comment_date_gmt > '" . $dateLimit . "'";
		} else if($type == 3) {
			$timeInterval = "AND c.comment_date_gmt > '" . $dateLimit . "'";
		}
	}
	if($options['time_limit_type'] == 3) {
		
		// define current day, month, year
		$currentDay = gmdate('j'); 
		$currentMonth = gmdate('n');
		$currentYear = gmdate('Y');
		
		// set current to the time
		$theDay = $currentDay;
		$theMonth = $currentMonth;
		$theYear = $currentYear;
			
		/* if this week, get the start of week */
		if($options['time_limit_this'] == 1) {
			// set array of how many days into the week, Sunday = 0
			$weekArray = array(	'Sunday' => 0, 'Monday' => 1, 'Tuesday' => 2, 'Wednesday' => 3, 'Thursday' => 4, 'Friday' => 5, 'Saturday' => 6 );
	
			$currentDayOfWeek = gmdate('l'); // get day of week
			
			// get starting day of week. Used this method to support PHP4, only PHP5 can get current day directly.
			$theDay = $theDay - $weekArray[$currentDayOfWeek];
		}
		/* if this month, set day = 1 */
		if($options['time_limit_this'] == 2) {
			$theDay = 1;
		}
		/* if this year, set day, month = 1 */
		if($options['time_limit_this'] == 3) {
			$theDay = 1;
			$theMonth = 1;
		}
			
		$subTime = mktime(0, 0, 0, $theMonth, $theDay, $theYear);
		$dateLimit = gmdate('Y-m-d H:i:s', $subTime);
		if($type == 1) {
			$timeInterval = "AND a.post_date_gmt > '" . $dateLimit . "'";
		} else if($type == 2) {
			$timeInterval = "AND comment_date_gmt > '" . $dateLimit . "'";
		} else if($type == 3) {
			$timeInterval = "AND c.comment_date_gmt > '" . $dateLimit . "'";
		}
	}
	return $timeInterval;	
}

function jme_sanitize_js($str) {
	return str_replace('"','\"',stripslashes($str));
}

function jme_top_contributors_init() {
	global $jmetcop;
	if(!is_admin()) {
		if($jmetcop['comment']['format'] == 2 || $jmetcop['author']['format'] == 2) {
			wp_register_script( 'jmetc-dim', JMETC_PLUGINPATH.'js/jquery.dimensions.js', array('jquery'), '' );
			wp_register_script( 'jmetc-tt', JMETC_PLUGINPATH.'js/jquery.tooltip.js', array('jquery'), '' );
			wp_enqueue_script( 'jmetc-dim' );
			wp_enqueue_script( 'jmetc-tt' );
		}
		wp_register_style( 'jmetc-css', JMETC_PLUGINPATH . "css/tooltip.css" );	
		wp_enqueue_style( 'jmetc-css' );
	}
}
function jme_top_contributors_tooltip() {
	global $jmetcop;
	if($jmetcop['comment']['format'] == 2 || $jmetcop['author']['format'] == 2) {
		echo "<script type=\"text/javascript\">jQuery(document).ready(function($) { jQuery('.top-contributors img').tooltip({delay:0,showURL:false,}); });</script>\n";
	}
}

function jme_tc_icon($user) {
	global $jmetcop;
	$string = $user;
	$user = strip_tags($user);
	if($jmetcop['icon']['show_icon'] == 1) {
		if(in_array($user, $jmetcop['comment']['toplist']['name'])) {
			$string = $string . ' ';		
			$starList = explode(",",$jmetcop['icon']['comment_limit']);

			/*
				Loop through each threshold limit and check if user post count is above
				that threshold limit, and add a star if it does
			*/
			for($i=0;$i<count($starList);$i++) {
				if($jmetcop['comment']['toplist']['post_count'][$user] >= $starList[$i]) {

					$string .= '<img class="tc-icon" src="' . JMETC_PLUGINPATH . 'images/' . $jmetcop['icon']['icon'] . '" alt="" title="' . __('Top Contributor', 'jmetc') . '" />';
				}
			}
		}
	}
	return $string;
}

function jmetc_settings_link($links, $file) {
	static $this_plugin;
 
	if( !$this_plugin ) $this_plugin = plugin_basename(__FILE__);
 
	if( $file == $this_plugin ){
		$settings_link = '<a href="options-general.php?page='.dirname(plugin_basename(__FILE__)).'.php">' . __('Settings') . '</a>';
		$links = array_merge( array($settings_link), $links); // before other links
	}
	return $links;
}

function jmetc_rel_link($rel) {
	switch($rel) {
		case 1 : $jmevar['rel'] = 'rel="nofollow" '; break;
		case 2 : $jmevar['rel'] = 'rel="dofollow" '; break;
		default : $jmevar['rel'] = '';
	}
	return $jmevar['rel'];
}
function jmetc_do_keywordluv($name,$url,$kwl,$rel) {
	if(strpos($name,'@') && $url != '' && $kwl == 1) {
		$part = explode('@',$name);
		return trim($part[0]) . ' ' . __('from','jmetc') . ' <a ' . jmetc_rel_link($rel) . 'href="' . $url . '">' . trim($part[1]) . '</a>';
	} else if($url != '') {
		return '<a ' . jmetc_rel_link($rel) . 'href="' . $url . '">' . $name . '</a>';
	} else {
		return $name;
	}
}

?>